/*
License for ScriptEd

Copyright 2005 by Steven Berry <berrys66@yahoo.co.uk>

All Rights Reserved 

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that 
both that copyright notice and this permission notice appear in 
supporting documentation. 

STEVEN BERRY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS, IN NO EVENT SHALL STEVEN BERRY BE LIABLE FOR ANY 
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER 
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE 
OR PERFORMANCE OF THIS SOFTWARE. 
*/


// Basic windows registry wrapper class
// (mainly to avoid using MFC's CRegKey class)

#ifndef _CREGISTRY_H_
#define _CREGISTRY_H_

#include <windows.h>

class CRegistry
{
	private:
		HKEY hK ;
		bool KeyIsOpen ;

	public:
		CRegistry() ;
		~CRegistry() ;
		bool OpenKey(HKEY, const char *, bool create = false) ;
		bool GetValue(const char *, long *) ;
		bool GetValue(const char *, char *, unsigned long) ;
		bool SetValue(const char *, long) ;
		bool SetValue(const char *, const char *, unsigned long) ;
} ;

#endif
