/*
License for ScriptEd

Copyright 2005 by Steven Berry <berrys66@yahoo.co.uk>

All Rights Reserved 

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that 
both that copyright notice and this permission notice appear in 
supporting documentation. 

STEVEN BERRY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS, IN NO EVENT SHALL STEVEN BERRY BE LIABLE FOR ANY 
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER 
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE 
OR PERFORMANCE OF THIS SOFTWARE. 
*/

#ifndef _CCONCAT_H_
#define _CCONCAT_H_

typedef struct tagStrNode
{
	unsigned long		FragLen ;
	char				*Frag ;
	struct tagStrNode	*Next ;
} STRNODE ;

class CConcat
{

	private:
		STRNODE			*Top ;
		STRNODE			*Last ;
		unsigned long	StringLength ;

		char			*cc_strdup(const char *StrToDup) ;
		unsigned long	cc_strlen(const char *Str) ;
		void			KillString(void) ;

	public:
		CConcat() ;								// Default constructor
		~CConcat() ;							// Destructor
		void Append(const char *Fragment) ;		// Append a string fragment
		char *ToString(void) ;					// Return the concatenated string
		void Reset(void) ;						// Reset (delete) the string ;
} ;


#endif
