/*
License for ScriptEd

Copyright 2005 by Steven Berry <berrys66@yahoo.co.uk>

All Rights Reserved 

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that 
both that copyright notice and this permission notice appear in 
supporting documentation. 

STEVEN BERRY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS, IN NO EVENT SHALL STEVEN BERRY BE LIABLE FOR ANY 
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER 
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE 
OR PERFORMANCE OF THIS SOFTWARE. 
*/

/*
 * Based on the Scintilla sample app
 */

#ifndef _CSCRE_H_
#define _CSCRE_H_

#include <windows.h>
#include <richedit.h>

#include "Scintilla.h"
#include "SciLexer.h"
#include "resource.h"

#define CALL_TIP_SIZE	4096
#define DWELL_TIME		500

const char appName[] = "ScriptEd" ;
const int blockSize = 128 * 1024 ;

class ScrEApp
{
	private:
		char acBuff[MAX_PATH], *acbp ;
		const char *tip_name, *tip_cat, *tip_subcat, *tip_usage, *tip_desc ;
		char CallTip[CALL_TIP_SIZE], CallTipMsg[CALL_TIP_SIZE] ;
		bool tips_on ;

	public:

		HINSTANCE hInstance;
		HWND currentDialog;
		HWND wMain;
		HWND wEditor;
		bool isDirty;
		char fullPath[MAX_PATH];
		char fnbuff[MAX_PATH] ;

		ScrEApp(void);
		~ScrEApp(void) ;
		LRESULT SendEditor(UINT Msg, WPARAM wParam=0, LPARAM lParam=0) 
		{
			return ::SendMessage(wEditor, Msg, wParam, lParam);
		}
		void GetRange(int, int, char *);
		void SetTitle(void);
		void New(void);
		void OpenFile(const char *);
		void Save(void);
		void SaveFile(const char *);
		int SaveIfUnsure(void);
		void EnableAMenuItem(int, bool);
		void CheckMenus(void);
		void Notify(SCNotification *);
		void SetAStyle(int style, COLORREF fore, COLORREF back=RGB(0xff,0xff,0xff), int size=-1, const char *face=0);
		void InitialiseEditor(void);

} ;


#endif
