/*
License for ScriptEd

Copyright 2005 by Steven Berry <berrys66@yahoo.co.uk>

All Rights Reserved 

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that 
both that copyright notice and this permission notice appear in 
supporting documentation. 

STEVEN BERRY DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS 
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY 
AND FITNESS, IN NO EVENT SHALL STEVEN BERRY BE LIABLE FOR ANY 
SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, 
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER 
TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE 
OR PERFORMANCE OF THIS SOFTWARE. 
*/

#ifndef _XMLERROR_H_
#define _XMLERROR_H_


/* XML Parse errors  */
#define E_XML_NODATA        1001
#define E_XML_NODTD         1002
#define E_XML_INVALID_CHAR  1003
#define E_XML_INVALID_TAG   1004
#define E_XML_MODE          1005
#define E_XML_MATCH         1006
#define E_XML_MISSING       1007
#define E_XML_BAD_ATTR      1008
#define E_XML_ATTR_VAL      1009
#define E_XML_FILE_STAT     1010
#define E_XML_FILE_ALLOC    1011
#define E_XML_FILE_OPEN     1012
#define E_XML_FILE_READ     1013
#define E_XML_INVALID_CHAR2 1014
#define E_XML_ALREADY       1015

/* XML Validate errors  */
#define E_XML_NOXML         1051
#define E_XML_READY         1052
#define E_XML_ELEMENT       1053
#define E_XML_HASATTR       1054
#define E_XML_ATTRREQ       1055
#define E_XML_ATTRFIXVAL    1056
#define E_XML_DTDELEMENT    1057
#define E_XML_ATTRBADVAL    1058
#define E_XML_ATTRBADENUM   1059
#define E_XML_DTDBADSIB     1060
#define E_XML_ATTRNAME      1061

/* DTD Parse errors  */
#define E_DTD_INVALID_CHAR  2001
#define E_DTD_INVALID       2002
#define E_DTD_BAD_ATTR      2003
#define E_DTD_ATTR_VAL      2004
#define E_DTD_CONTENT_TYPE  2005
#define E_DTD_ENTITY_SUBS   2006
#define E_DTD_ENTITY_BAD    2007
#define E_DTD_ELEMENT_GROUP 2008
#define E_DTD_ELEMENT_BAD   2009
#define E_DTD_CONTENT_BAD   2010
#define E_DTD_ATTR_TYPE     2011
#define E_DTD_ATTR_REQ      2012
#define E_DTD_ATTR_NAME     2013
#define E_DTD_ATTR_FIX      2014
#define E_DTD_ATTR_QUOTE    2015
#define E_DTD_ATTR_ENUM     2016
#define E_DTD_ATTR_ENUM_DEF 2017
#define E_DTD_NODTD         2018
#define E_DTD_READY         2019
#define E_DTD_ALREADY       2020

/* XML Doc generation errors   */
#define E_DOC_ELEMENT       3001
#define E_DOC_INIT          3002
#define E_DOC_NOT_INIT      3003
#define E_DOC_FIRSTCHILD    3004
#define E_DOC_SIBLING       3005
#define E_DOC_SETVALUE      3006
#define E_DOC_MALLOC        3007
#define E_DOC_READY         3008
#define E_DOC_DTDATTR       3009
#define E_DOC_HASATTR       3010
#define E_DOC_ATTRNAME      3011
#define E_DOC_ATTRREQ       3012
#define E_DOC_ATTRFIXVAL    3013
#define E_DOC_ATTRBADVAL    3014
#define E_DOC_ATTRBADENUM   3015
#define E_DOC_COPYNOXML     3016
#define E_DOC_ADDFRAG       3017
#define E_DOC_DELETE        3018
#define E_DOC_ADDCDATA      3019

/* Internal errors - should never happen, but there you are! */
#define E_XML_INTERNAL      9001
#define E_DTD_INTERNAL      9002
#define E_DOC_INTERNAL      9003

#endif
